unit Main;

{$mode objfpc}{$H+}

interface

uses
  Classes, ExtCtrls, PrintersDlgs, StdCtrls, SysUtils, FileUtil, Forms,
  Controls, Graphics, Dialogs, TAGraph, TASeries, TASources, TAChartListbox;

type

  { TForm1 }

  TForm1 = class(TForm)
    BarView: TChart;
    BarViewBarSeries1: TBarSeries;
    BarViewBarSeries2: TBarSeries;
    BarViewBarSeries3: TBarSeries;
    BarViewBarSeries4: TBarSeries;
    BarViewBarSeries5: TBarSeries;
    BarViewBarSeries6: TBarSeries;
    BarViewBarSeries7: TBarSeries;
    BarViewBarSeries8: TBarSeries;
    Button2: TButton;
    ListChartSource: TListChartSource;
    MyImage: TImage;
    Panel1: TPanel;
    Panel2: TPanel;
    Print: TButton;
    PrintCanvas: TButton;
    PrintDialog1: TPrintDialog;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PrintClick(Sender: TObject);
  end;

var
  Form1: TForm1; 

implementation

uses
  OSPrinters, TAPrint, Printers;

{$R *.lfm}

{ TForm1 }

procedure TForm1.PrintClick(Sender: TObject);
const
  MARGIN = 10;

var
  r: TRect;
  d: Integer;

begin

  if not PrintDialog1.Execute then exit;


  Printer.Begindoc;
  try
    r := Rect(0, 0, Printer.PageWidth, Printer.PageHeight div 2);
    d := r.Right - r.Left;
    r.Left += d div MARGIN;
    r.Right -= d div MARGIN;
    d := r.Bottom - r.Top;
    r.Top += d div MARGIN;
    r.Bottom -= d div MARGIN;

    if Sender = PrintCanvas then
      BarView.PaintOnCanvas(Printer.Canvas, r)
    else
      BarView.Draw(TPrinterDrawer.Create(Printer), r);
  finally
    Printer.EndDoc;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin



end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  BarView.PaintOnCanvas(MyImage.Canvas, Rect(0, 0, MyImage.Width, MyImage.Height));
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   BarViewBarSeries1.AddXY(0, 50, '0.2µm '+ inttostr(50), clRed);
  BarViewBarSeries1.Title:='0.2µm: 50';
  BarViewBarSeries2.AddXY(1, 150, '0.3µm '+ inttostr(150), clblue);
  BarViewBarSeries2.Title:='0.3µm: 150';
  BarViewBarSeries3.AddXY(2, 250, '0.5µm '+ inttostr(250), clgreen);
  BarViewBarSeries3.Title:='0.5µm: 250';
  BarViewBarSeries4.AddXY(3, 350, '0.6µm '+ inttostr(350), clyellow);
  BarViewBarSeries4.Title:='0.6µm: 350';
  BarViewBarSeries5.AddXY(4, 450, '1.0µm '+ inttostr(450), clteal);
  BarViewBarSeries5.Title:='1.0µm: 450';
  BarViewBarSeries6.AddXY(5, 550, '2.0µm '+ inttostr(550), clNavy);
  BarViewBarSeries6.Title:='2.0µm: 550';
  BarViewBarSeries7.AddXY(6, 650, '5.0µm '+ inttostr(650), clPurple);
  BarViewBarSeries7.Title:='5.0µm: 650';
  BarViewBarSeries8.AddXY(7, 750, '10.0µm '+ inttostr(750), clGray);
  BarViewBarSeries8.Title:='10.0µm: 750';
end;

end.

